<?php

namespace App\Classes;

class TagFetcher extends PageFetcher
{
  public function fetch(string $tag, int $page = 1, int $pageSize = 20): ?array
  {
    $offset = ($page - 1) * $pageSize;
    $cacheKey = "tag_" . md5("{$tag}_{$page}");
    $cached = $this->cacheGet($cacheKey);

    if ($cached) return $cached;

    $results = $this->fetchPostRpc("rpc/get_tagged_content", [
      "tag_query" => $tag,
      "page_size" => $pageSize,
      "page_offset" => $offset
    ]);

    if (!$results || count($results) === 0) return null;

    $results[0]['globals'] = $this->getGlobals();

    $this->cacheSet($cacheKey, $results);

    return $results;
  }
}
