import { transliterate } from 'transliteration';

export const sanitizeMediaString = (input) => {
  const ascii = transliterate(input);
  const cleaned = ascii.replace(/[^a-zA-Z0-9\s-]/g, '');
  const slugified = cleaned.replace(/[\s-]+/g, '-').toLowerCase();

  return slugified.replace(/^-+|-+$/g, '');
}

export const removeUrlProtocol = (url) => url ? url.replace(/^https?:\/\//, '') : '';
