import truncateHtml from "truncate-html";

export default {
  encodeAmp: (string) => {
    if (!string) return;

    const pattern = /&(?!(?:[a-zA-Z]+|#[0-9]+|#x[0-9a-fA-F]+);)/g;
    const replacement = "&amp;";

    return string.replace(pattern, replacement);
  },
  replaceQuotes: (string) => {
    if (!string) return '';
    return string.replace(/"/g, "&quot;");
  },
  htmlTruncate: (content, limit = 50) => truncateHtml(content, limit, {
      byWords: true,
      ellipsis: "...",
    }),
  shuffleArray: (array) => {
    const shuffled = [...array];

    for (let i = shuffled.length - 1; i > 0; i--) {
      let j = Math.floor(Math.random() * (i + 1));
      let temp = shuffled[i];
      shuffled[i] = shuffled[j];
      shuffled[j] = temp;
    }

    return shuffled;
  },
  mergeArray: (a, b) => Array.isArray(a) && Array.isArray(b) ? [...new Set([...a, ...b])] : [],
  pluralize: (count, string, trailing) => {
    const countStr = String(count).replace(/,/g, "");

    if (parseInt(countStr, 10) === 1) return string;

    return `${string}s${trailing ? `${trailing}` : ''}`;
  },
  jsonEscape: (string) => JSON.stringify(string),
  regexEscape: (string) => string.replace(/[.*+?^${}()[]\\]/g, '\\$&')
};
