export default {
  getMetadata: (data = {}, globals = {}, page = {}, title = "", description = "", schema = "") => {
    const metadata = data?.metadata;
    const baseUrl = globals.url || "";
    const ogPath = "/og/w800";
    const image = metadata?.open_graph_image || globals.metadata?.open_graph_image || globals.avatar;
    const rawTitle = title || page.title || metadata?.title || globals.site_name;
    const resolvedTitle = rawTitle === globals.site_name ? globals.site_name : `${rawTitle} • ${globals.site_name}`;
    const resolvedDescription = description || metadata?.description || page.description || globals.site_description;
    const url = metadata?.url || (page.url ? `${baseUrl}${page.url}` : "#");

    return {
      title: resolvedTitle,
      description: resolvedDescription,
      url,
      open_graph_image: `${baseUrl}${ogPath}${image}`
    };
  }
};
