import EleventyFetch from "@11ty/eleventy-fetch";

const { POSTGREST_URL, POSTGREST_API_KEY } = process.env;

const fetchTopTags = async () => {
  try {
    return await EleventyFetch(`${POSTGREST_URL}/rpc/get_top_tag_groups`, {
      duration: "1h",
      type: "json",
      fetchOptions: {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
          Authorization: `Bearer ${POSTGREST_API_KEY}`,
        },
      },
    });
  } catch (error) {
    console.error("Error fetching top tag entries:", error);
    return [];
  }
};

export default async function () {
  return await fetchTopTags();
}
